"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  gql2TsConfig: () => gql2TsConfig,
  graphQLCodegen: () => graphQLCodegen,
  tagStr2DtsConfig: () => tagStr2DtsConfig
});
module.exports = __toCommonJS(src_exports);
var import_cli = require("@graphql-codegen/cli");
var import_worker_threads = require("worker_threads");
var import_comlink = require("comlink");
var import_node_adapter = __toESM(require("comlink/dist/umd/node-adapter"), 1);

// src/config.ts
var tagStr2DtsConfig = {
  overwrite: true,
  schema: "schema.graphql",
  generates: {
    "./src/graphql.gql.ts": {
      plugins: ["typescript"]
    },
    "./": {
      documents: ["src/**/*.ts", "!src/**/*.gql.ts"],
      preset: "near-operation-file",
      presetConfig: {
        baseTypesPath: "./src/graphql.gql.ts",
        extension: ".gql.ts"
      },
      plugins: ["typescript-operations"]
    }
  }
};
var gql2TsConfig = {
  overwrite: true,
  schema: "schema.graphql",
  generates: {
    "./src/graphql.generated.ts": {
      plugins: ["typescript"]
    },
    "./": {
      documents: ["src/**/*.gql"],
      preset: "near-operation-file",
      presetConfig: {
        baseTypesPath: "./src/graphql.generated.ts",
        extension: ".generated.ts"
      },
      plugins: ["typescript-operations", "typed-document-node"]
    }
  }
};

// src/index.ts
var import_fs_extra = require("@liuli-util/fs-extra");
var path = __toESM(require("path"), 1);
async function codegenDts(watch, config) {
  try {
    if (await (0, import_fs_extra.pathExists)("codegen.yml")) {
      const codegenContext = await (0, import_cli.loadContext)();
      codegenContext.updateConfig({
        watch
      });
      await (0, import_cli.generate)(codegenContext);
    } else {
      await (0, import_cli.generate)({
        ...config,
        cwd: path.resolve(),
        watch
      });
    }
  } catch (error) {
    console.log("Something went wrong.");
  }
}
if (!import_worker_threads.isMainThread) {
  (0, import_comlink.expose)(codegenDts, (0, import_node_adapter.default)(import_worker_threads.parentPort));
}
function graphQLCodegen(config = tagStr2DtsConfig) {
  return {
    name: "rollup-plugin-graphql-codegen",
    async buildStart() {
      await codegenDts(false, config);
      if (this.meta.watchMode) {
        const worker = new import_worker_threads.Worker(__filename);
        const codegenWorker = (0, import_comlink.wrap)((0, import_node_adapter.default)(worker));
        codegenWorker(this.meta.watchMode, config);
      }
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  gql2TsConfig,
  graphQLCodegen,
  tagStr2DtsConfig
});
